@echo off
rem *        THIS IS A BATCH FILE TO COPY FILES IN ALPHANUMERIC ORDER IN WINDOWS
rem *                           2010 dan schr - bafdataprocessing@bafweb.ch
rem *       
rem *         THIS IS HARDCODED TO MY SYSTEM TO COPY FILES TO MY MP3-PLAYER!
rem *       
rem *            You will probably need to edit some lines to make this work for you.
rem *                                               these lines ar marked with rem-lines like this:
rem *       - - - - - - - -     EDIT  -     EDIT  -   EDIT  -    EDIT  -    EDIT  -    EDIT    - - - - - - - -
rem *       
rem *                                                                AutoHotkey
rem *            This also uses a AutoHotkey Script. You will either need AutoHotKey on your System,
rem *            or to rewrite the script "COPYAlbG.ahk" in another script-language (see below).
rem *            (I guess it coud also be done in this batch file, but for me it was easyer this way.)
rem *            AutoHotkey is free. All you have to do, is download it from
rem *           http://www.autohotkey.com/download/
rem *            and run the installer.
rem *       
rem *       -------------------------------------------------------------------------------------------------- 
rem *       The script is called with the path of the folder to be copied as parameter:
rem *                             fldrcopy.bat "FOLDERPATH"
rem *                       This can be done from a program, a script or from the context-menu
rem *       example:     fldrcopy.bat "D:\Entertainment\Music\Various Artists\My Hits"
rem *       registry:     C:\mp3copy\fldrcopy.bat "%1" (adjust path)
rem *          The script then
rem *            - checks if the mp3-player is present
rem *            - makes a folder with the same name (My Hits) on the mp3-player
rem *            - copies the files in the folder in alpanumneric order to the folder on the mp3-player
rem *         Subdirectories are not copied.
rem *         If the folder already exists, no action is taken
rem *       --------------------------------------------------------------------- ----------------------------- 
rem *         
rem *   First, we nee to set the correct driveletters and paths. My player gets drivletter E: or G:,
rem *   and I have all files in a subfolder called "MUSIC".  I also have a folder MUSIC\SINGLES
rem *   for single songs. Some of these names are used to identify the player in the script.      
rem *       v v v v v v v v   EDIT   v   EDIT   v   EDIT   v   EDIT   v   EDIT   v   EDIT   v v v v v v v v 
rem *       v v v v v v v v   EDIT   v   EDIT   v   EDIT   v   EDIT   v   EDIT   v   EDIT   v v v v v v v v 
rem *       v v v v v v v v   EDIT   v   EDIT   v   EDIT   v   EDIT   v   EDIT   v   EDIT   v v v v v v v v 
rem *       v v v v v v v v   EDIT   v   EDIT   v   EDIT   v   EDIT   v   EDIT   v   EDIT   v v v v v v v v 
rem *       v v v v v v v v   EDIT   v   EDIT   v   EDIT   v   EDIT   v   EDIT   v   EDIT   v v v v v v v v 
rem *       v v v v v v v v   EDIT   v   EDIT   v   EDIT   v   EDIT   v   EDIT   v   EDIT   v v v v v v v v 
rem *       v v v v v v v v   EDIT   v   EDIT   v   EDIT   v   EDIT   v   EDIT   v   EDIT   v v v v v v v v 
rem *    First, we need to know, where these script-files are (full path with driveletter):
set cscrdir=C:\mp3copy
rem *    Set possible driveletters (if you want to try more than three, you'll have to expand the script):
set drvlone=E
set drvltwo=F
set drvlthr=G
rem *    set identification variable (this must be a file or folder, that is always on the player).   
set idfle=MUSIC\SINGLES
rem *     set the folder, where the albums should be stored on the mp3-player  
set albfld=MUSIC
rem *       ^ ^ ^ ^ ^ ^ ^  EDIT   ^   EDIT  ^   EDIT  ^    EDIT  ^   EDIT  ^    EDIT   ^ ^ ^ ^ ^ ^ ^  
rem *       ^ ^ ^ ^ ^ ^ ^  EDIT   ^   EDIT  ^   EDIT  ^    EDIT  ^   EDIT  ^    EDIT   ^ ^ ^ ^ ^ ^ ^  
rem *       ^ ^ ^ ^ ^ ^ ^  EDIT   ^   EDIT  ^   EDIT  ^    EDIT  ^   EDIT  ^    EDIT   ^ ^ ^ ^ ^ ^ ^  
rem *       ^ ^ ^ ^ ^ ^ ^  EDIT   ^   EDIT  ^   EDIT  ^    EDIT  ^   EDIT  ^    EDIT   ^ ^ ^ ^ ^ ^ ^  
rem *       ^ ^ ^ ^ ^ ^ ^  EDIT   ^   EDIT  ^   EDIT  ^    EDIT  ^   EDIT  ^    EDIT   ^ ^ ^ ^ ^ ^ ^  
rem *       ^ ^ ^ ^ ^ ^ ^  EDIT   ^   EDIT  ^   EDIT  ^    EDIT  ^   EDIT  ^    EDIT   ^ ^ ^ ^ ^ ^ ^  
rem *       ^ ^ ^ ^ ^ ^ ^  EDIT   ^   EDIT  ^   EDIT  ^    EDIT  ^   EDIT  ^    EDIT   ^ ^ ^ ^ ^ ^ ^  

rem *            Check the first driveletter
if not exist %drvlone%:\%idfle% GOTO NOTDISKONE
set drvlet=%drvlone%
GOTO YESDISK
GOTO END

:NOTDISKONE
rem *            Check the second driveletter
if not exist %drvltwo%:\%idfle% GOTO NOTDISKTWO
set drvlet=%drvltwo%
GOTO YESDISK
GOTO END

:NOTDISKTWO
rem *            Check the second driveletter
if not exist %drvlthr%:\%idfle% GOTO NOMPFOUND
set drvlet=%drvlthr%
GOTO YESDISK
GOTO END

:NOMPFOUND
rem *            The mp3-player was not found
echo *
echo *
echo *      mp3-player not found
echo *      
echo *     
echo *      
echo *     NO DATA WAS COPIED!!
echo *
echo *
echo *    press any key...
timeout /T 30 > nul
GOTO END


:YESDISK
rem *            If folder doen't already exist,  make a copy
if not exist "%drvlet%:\%albfld%\%~nx1" GOTO COPYFLDFLS
rem *            folder already exists - don't do anything
echo *
echo *
echo *     
echo *                A folder called
echo *         %~n1
echo *                  already exists.
echo *      
echo *     NO DATA WAS COPIED!!
echo *      
echo *
echo *    press any key...
timeout /T 40 > nul
GOTO END

:COPYFLDFLS
rem *           make folder and copy files
echo *
echo *
echo *          copying folder
echo *        %~nx1
echo *            to %drvlet%:\%albfld%
echo *           
rem *           make folderon mp3-player
%drvlet%:
cd %drvlet%:\%albfld%
md "%~nx1"
rem *           delete old listing (optional)
del %cscrdir%\mpdlist.txt
echo *
echo *
echo *
echo *
rem *           change to the folder that has to be copied
%~d1
cd "%~dpnx1"
rem *       v v v v v v v v   EDIT   v   EDIT   v   EDIT   v   EDIT   v   EDIT   v   EDIT   v v v v v v v v 
rem *       v v v v v v v v   EDIT   v   EDIT   v   EDIT   v   EDIT   v   EDIT   v   EDIT   v v v v v v v v 
rem *       v v v v v v v v   EDIT   v   EDIT   v   EDIT   v   EDIT   v   EDIT   v   EDIT   v v v v v v v v 
rem *           make a filelist (no directories, simple list, order by name) and store it in mpdlist.txt
rem *             you can filter out just mp3-files  with dir *.mp3 /A.:-D /B /O:N
dir /A:-D /B /O:N  > %cscrdir%\mpdlist.txt
rem *       ^ ^ ^ ^ ^ ^ ^  EDIT   ^   EDIT  ^   EDIT  ^    EDIT  ^   EDIT  ^    EDIT   ^ ^ ^ ^ ^ ^ ^  
rem *       ^ ^ ^ ^ ^ ^ ^  EDIT   ^   EDIT  ^   EDIT  ^    EDIT  ^   EDIT  ^    EDIT   ^ ^ ^ ^ ^ ^ ^  
rem *       ^ ^ ^ ^ ^ ^ ^  EDIT   ^   EDIT  ^   EDIT  ^    EDIT  ^   EDIT  ^    EDIT   ^ ^ ^ ^ ^ ^ ^  
rem *       v v v v v v v v   EDIT   v   EDIT   v   EDIT   v   EDIT   v   EDIT   v   EDIT   v v v v v v v v 
rem *       call a script, that reads the mpdlist.txt line by line and copies the files
rem *              You must have Autohotkey www.autohotkey.com on your system
rem *              to run the script called in the next card
%cscrdir%\COPYAlbG.ahk "%~dpnx1" "%drvlet%:\%albfld%\%~nx1" "%cscrdir%"
rem *       ^ ^ ^ ^ ^ ^ ^  EDIT   ^   EDIT  ^   EDIT  ^    EDIT  ^   EDIT  ^    EDIT   ^ ^ ^ ^ ^ ^ ^  
rem *           Go to the folder on the mp3-player and show its contents
%drvlet%:
cd %drvlet%:\%albfld%\%~nx1"
echo *
echo *
echo *           The following files are now in folder
echo *       %drvlet%:\%albfld%\%~nx1:
echo *     
echo *
echo *
timeout /T 3 > nul
dir /B /O:N
timeout /T 3 > nul
echo *
echo *    press any key...
timeout /T 60 > nul
GOTO END

:END
rem pause