@echo off
rem *        THIS IS A BATCH FILE TO COPY MP3-FILES TO A DESIGNATED FOLDER
rem *                           2010 dan schr - bafdataprocessing@bafweb.ch
rem *       
rem *         THIS IS HARDCODED TO MY SYSTEM TO COPY FILES TO MY MP3-PLAYER!
rem *       
rem *            You will probably need to edit some lines to make this work for you.
rem *                                               these lines ar marked with rem-lines like this:
rem *       - - - - - - - -     EDIT  -     EDIT  -   EDIT  -    EDIT  -    EDIT  -    EDIT    - - - - - - - -
rem * 
rem * 
rem *       
rem *       -------------------------------------------------------------------------------------------------- 
rem *       The script is called with the path of the fileto be copied as parameter:
rem *                             mpcopy.bat "FILEPATH"
rem *                       This can be done from a program, a script or from the context-menu
rem *       example:     mpcopy.bat "D:\Music\My Hits\02-The Beatles-You Know My Name"
rem *       registry:     C:\mp3copy\mpcopy.bat "%1" (adjust path)
rem *          The script then
rem *            - checks if the mp3-player is present
rem *            - copies the file to a designated folder on the mp3-player
rem *         If the file is already present, no action is taken
rem *       --------------------------------------------------------------------- ----------------------------- 
rem *         
rem *         
rem *         
rem *         
rem *         
rem *         
rem *         
rem *         
rem *         
rem *   First, we nee to set the correct driveletters and paths. My player gets drivletter E: or G:,
rem *   and I have all files in a subfolder called "MUSIC".  I also have a folder MUSIC\SINGLES
rem *   for single songs. Some of these names are used to identify the player in the script.      
rem *       v v v v v v v v   EDIT   v   EDIT   v   EDIT   v   EDIT   v   EDIT   v   EDIT   v v v v v v v v 
rem *       v v v v v v v v   EDIT   v   EDIT   v   EDIT   v   EDIT   v   EDIT   v   EDIT   v v v v v v v v 
rem *       v v v v v v v v   EDIT   v   EDIT   v   EDIT   v   EDIT   v   EDIT   v   EDIT   v v v v v v v v 
rem *       v v v v v v v v   EDIT   v   EDIT   v   EDIT   v   EDIT   v   EDIT   v   EDIT   v v v v v v v v 
rem *       v v v v v v v v   EDIT   v   EDIT   v   EDIT   v   EDIT   v   EDIT   v   EDIT   v v v v v v v v 
rem *       v v v v v v v v   EDIT   v   EDIT   v   EDIT   v   EDIT   v   EDIT   v   EDIT   v v v v v v v v 
rem *       v v v v v v v v   EDIT   v   EDIT   v   EDIT   v   EDIT   v   EDIT   v   EDIT   v v v v v v v v 
rem *    First, we need to know, where these script-files are (full path with driveletter):
set cscrdir=C:\mp3copy
rem *    Set possible driveletters (if you want to try more than three, you'll have to expand the script):
set drvlone=E
set drvltwo=F
set drvlthr=G
rem *    set identification variable (this must be a file or folder, that is always on the player).   
set idfle=MUSIC\SINGLES
rem *     set the folder, where the files should be stored on the mp3-player  
set mpfld=MUSIC\SINGLES
rem *       ^ ^ ^ ^ ^ ^ ^  EDIT   ^   EDIT  ^   EDIT  ^    EDIT  ^   EDIT  ^    EDIT   ^ ^ ^ ^ ^ ^ ^  
rem *       ^ ^ ^ ^ ^ ^ ^  EDIT   ^   EDIT  ^   EDIT  ^    EDIT  ^   EDIT  ^    EDIT   ^ ^ ^ ^ ^ ^ ^  
rem *       ^ ^ ^ ^ ^ ^ ^  EDIT   ^   EDIT  ^   EDIT  ^    EDIT  ^   EDIT  ^    EDIT   ^ ^ ^ ^ ^ ^ ^  
rem *       ^ ^ ^ ^ ^ ^ ^  EDIT   ^   EDIT  ^   EDIT  ^    EDIT  ^   EDIT  ^    EDIT   ^ ^ ^ ^ ^ ^ ^  
rem *       ^ ^ ^ ^ ^ ^ ^  EDIT   ^   EDIT  ^   EDIT  ^    EDIT  ^   EDIT  ^    EDIT   ^ ^ ^ ^ ^ ^ ^  
rem *       ^ ^ ^ ^ ^ ^ ^  EDIT   ^   EDIT  ^   EDIT  ^    EDIT  ^   EDIT  ^    EDIT   ^ ^ ^ ^ ^ ^ ^  
rem *       ^ ^ ^ ^ ^ ^ ^  EDIT   ^   EDIT  ^   EDIT  ^    EDIT  ^   EDIT  ^    EDIT   ^ ^ ^ ^ ^ ^ ^  

rem *            Check the first driveletter
if not exist %drvlone%:\%idfle% GOTO NOTDISKONE
set drvlet=%drvlone%
GOTO YESDISK
GOTO END

:NOTDISKONE
rem *            Check the second driveletter
if not exist %drvltwo%:\%idfle% GOTO NOTDISKTWO
set drvlet=%drvltwo%
GOTO YESDISK
GOTO END

:NOTDISKTWO
rem *            Check the second driveletter
if not exist %drvlthr%:\%idfle% GOTO NOMPFOUND
set drvlet=%drvlthr%
GOTO YESDISK
GOTO END

:NOMPFOUND
rem *            The mp3-player was not found
echo *
echo *
echo *      mp3-player not found
echo *      
echo *     
echo *      
echo *     NO DATA WAS COPIED!!
echo *
echo *
echo *    press any key...
timeout /T 30 > nul
GOTO END


:YESDISK
rem *            If the file isn't already there, copy it
if not exist "%drvlet%:\%mpfld%\%~nx1" GOTO COPYMP
rem *            file already exists - don't do anything
echo *
echo *
echo *     
echo *                A file called
echo *            %~nx1
echo *                  already exists.
echo *      
echo *     NO DATA WAS COPIED!!
echo *      
echo *
echo *    press any key...
timeout /T 40 > nul
GOTO END

:COPYMP
rem *            copy the file
echo *
echo *            copying
echo *        %~n1%~x1:
copy %~s1 "%drvlet%:\%mpfld%\%~nx1"
echo *
echo *
echo *    press any key...
timeout /T 5 > nul
GOTO END





:END
rem pause